<script lang="ts">
  import { base } from '$app/paths';
  import { onDestroy, onMount } from 'svelte';
  import { MetaTags } from 'svelte-meta-tags';
  import { replace } from 'svelte-spa-router';

  import Modal from '@/components/modal.svelte';

  import {
    audioExtension,
    audioType,
    download,
    getMediaRecorderAndStream,
    iCanHasMediaDevices,
    noOp,
    randomFileName
  } from '@/utils';

  let audioChunks: Blob[] = [];
  let isRecordingAudio = false;
  let audioRecorder: MediaRecorder | null = null;
  let error: string | null = null;
  let iCanHasPlay = false;
  let iCanHasUpDownAudio = false;
  let iCanHasSubmitAudio = false;
  /**
   * Handle data available event.
   * @param {BlobEvent} event - The event.
   * @returns {void}
   */
  const onDataAvailable = (event: BlobEvent): void => {
    if (event.data.size > 0) {
      audioChunks.push(event.data);
    }
    const audioEl = document.querySelector('audio');
    if (audioEl && audioRecorder && audioRecorder.state === 'inactive' && audioChunks.length > 0) {
      const audioBlob = new Blob(audioChunks, { type: audioType() });
      audioEl.src = URL.createObjectURL(audioBlob);
      iCanHasUpDownAudio = true;
      iCanHasPlay = true;
    } else {
      iCanHasUpDownAudio = false;
      iCanHasPlay = false;
    }
  };
  /**
   * Start audio recording.
   * @returns {void}
   */
  const startRecording = (): void => {
    if (!isRecordingAudio) {
      iCanHasPlay = false;
      iCanHasUpDownAudio = false;
      audioChunks = [];
      if (audioRecorder) {
        audioRecorder.start();
      }
      isRecordingAudio = true;
    }
  };
  /**
   * Stop audio recording.
   * @returns {void}
   */
  const stopRecording = (): void => {
    if (isRecordingAudio) {
      if (audioRecorder) {
        audioRecorder.stop();
      }
      isRecordingAudio = false;
    }
  };
  /**
   * Download audio.
   * @returns {void}
   */
  const _download = (): void => {
    const audioBlob = new Blob(audioChunks, { type: audioType() });
    const filename = randomFileName('recording', audioExtension());
    download(audioBlob, filename);
  };
  /**
   * Toggle modal visibility.
   * @returns {void}
   */
  const toggleModal = (): void => {
    iCanHasSubmitAudio = !iCanHasSubmitAudio;
  };
  /**
   * Convert audio chunks to file.
   * @returns {File} The file.
   */
  const toFile = (): File => {
    const audioBlob = new Blob(audioChunks, { type: audioType() });
    const filename = randomFileName('recording', audioExtension());
    const audioFile = new File([audioBlob], filename, { type: audioType() });
    return audioFile;
  };
  /**
   * On mount hook
   * @returns {void}
   */
  onMount(() => {
    if (!iCanHasMediaDevices()) {
      error = 'Your browser does not support the MediaRecorder API.';
    }
    getMediaRecorderAndStream(false, true, 'user', (result) => {
      if (!result) {
        error =
          'Your browser does not support the MediaRecorder API,or no permission to use the microphone is granted';
        return;
      }
      audioRecorder = result.recorder;
      audioRecorder.addEventListener('dataavailable', onDataAvailable);
    });
  });
  /**
   * On destroy hook.
   * @returns {void}
   */
  onDestroy(() => {
    if (audioRecorder) {
      audioRecorder.removeEventListener('dataavailable', onDataAvailable);
    }
  });
</script>

<MetaTags title="Collect - Audio" description="Collect audio samples from your device." />
<div>
  <h1>Audio</h1>
  <h2 style="width: 100vw;text-align:center">
    <a href="{base}/#/" on:click={() => replace(`${base}/#/`)}>Home</a>
  </h2>
  <div>
    {#if error}
      <div class="error">{error}</div>
    {:else if iCanHasMediaDevices()}
      <div class="audio-actions">
        <i
          class="fa-2x fa-solid fa-microphone"
          style="display: {isRecordingAudio ? 'none' : 'initial'}"
          id="audio-record"
          aria-roledescription="Start recording"
          role="button"
          tabindex="0"
          on:click={startRecording}
          on:keydown={noOp}
        />
        <i
          class="fa-2x fa-solid fa-stop-circle"
          style="display: {isRecordingAudio ? 'initial' : 'none'}"
          id="audio-stop"
          aria-roledescription="Stop recording"
          role="button"
          tabindex="0"
          on:click={stopRecording}
          on:keydown={noOp}
        />
        <i
          class="fa-2x fa-solid fa-download"
          style="display: {iCanHasUpDownAudio ? 'initial' : 'none'};margin-left: 40px"
          id="audio-download"
          aria-roledescription="Download recording"
          role="button"
          tabindex="0"
          on:click={_download}
          on:keydown={noOp}
        />
        <i
          class="fa-2x fa-solid fa-upload"
          style="display: {iCanHasUpDownAudio ? 'initial' : 'none'};margin-left: 40px"
          id="audio-upload"
          aria-roledescription="Upload recording"
          role="button"
          tabindex="0"
          on:click={toggleModal}
          on:keydown={noOp}
        />
      </div>
      <div class="audio-wrapper" style="display: {iCanHasPlay ? 'flex' : 'none'}">
        <audio id="audio" controls />
      </div>
      {#if iCanHasSubmitAudio}
        <Modal on:click={toggleModal} file={toFile()} />
      {/if}
    {/if}
  </div>
</div>

<style>
  .audio-actions {
    display: flex;
    align-items: center;
    justify-content: center;
    max-width: 100px;
    margin: 20px auto;
  }
  .audio-wrapper {
    display: flex;
    justify-content: center;
    align-items: center;
  }
  .audio-wrapper audio {
    width: 100%;
    max-width: 480px;
  }
</style>
